#include <conio.h>
#include <unistd.h>
#include <dmotor.h>
#include <dsensor.h>
#include <dbutton.h>
#include <rom/lcd.h>
#include <time.h>

int main(int argc, char **argv) {
  long offset;
  long err, err_diff, err_int = 0, err_old;
  long pid;
  int direction;
  time_t starttime;
  
  int Kd = 210, Kp = 180, Ki = 10;

  ds_active(&SENSOR_1);
  ds_active(&SENSOR_3);
  msleep(20);
  offset = (long)SENSOR_1 - (long)SENSOR_3;
  cputs("yal2");
  sleep(2);
  err_old = 0;

  starttime = get_system_up_time();

  while(1)
  {
    err = (long)SENSOR_1 - (long)SENSOR_3 - offset;
    err_int = err_int + err + err_old;
    err_diff = (err - err_old);
    err_old = err;
    
    pid = (Kd * err_diff + Kp * err + Ki * err_int) /3000l;


    if (pid > 255) pid = 255;
    if (pid < -255) pid = -255;

    if (pid < 0)
    {
      direction = rev;
      pid = -pid;
    }
    else
    {
      direction = fwd;
      pid = pid;
    }
    if (pid < 5)
      direction=brake;

    lcd_int(pid);
    lcd_refresh();

    if(((get_system_up_time() - starttime) & 0xc00) == 0x800)
    {
      motor_a_dir(off);
      motor_c_dir(off);
      err_int = 0;
    }
    else
    {
      motor_a_dir(direction);
      motor_a_speed(pid);
      motor_c_dir(direction);
      motor_c_speed(pid);
    }
    if(PRESSED(dbutton(), BUTTON_PROGRAM))
    {
      motor_a_dir(brake);
      motor_c_dir(brake);
      ds_passive(&SENSOR_1);
      ds_passive(&SENSOR_3);
      cputs("stop");
      msleep(300);
      while (PRESSED(dbutton(), BUTTON_PROGRAM));
      motor_a_dir(off);
      motor_c_dir(off);
      cls();
      return(0);
    }
    msleep(20);
  }
}
